# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class AccessTokenResponse(BaseModel):
    """
    AccessTokenResponse
    """ # noqa: E501
    access_token: Optional[StrictStr] = Field(default=None, description="A JWT bearer access token that can be used to access the public API.")
    token_type: Optional[StrictStr] = Field(default=None, description="The type of token.")
    expires_in: Optional[StrictInt] = Field(default=None, description="Timestamp that the token will expire in seconds after the UNIX epoch.")
    scope: Optional[StrictStr] = Field(default=None, description="Space delimited list of scopes granted to the access token.")
    refresh_token: Optional[StrictStr] = Field(default=None, description="Contains a token you can use to refresh the bearer access token.")
    id_token: Optional[StrictStr] = Field(default=None, description="A JWT token that contains information about user authentication.")
    __properties: ClassVar[List[str]] = ["access_token", "token_type", "expires_in", "scope", "refresh_token", "id_token"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AccessTokenResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of AccessTokenResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "access_token": obj.get("access_token"),
            "token_type": obj.get("token_type"),
            "expires_in": obj.get("expires_in"),
            "scope": obj.get("scope"),
            "refresh_token": obj.get("refresh_token"),
            "id_token": obj.get("id_token")
        })
        return _obj


