# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ContactOpenAndClickRates(BaseModel):
    """
    The average click and open rates for a provided contact. The basic information provided is contact id, open rate, click rate, and emails included in the calculation.
    """ # noqa: E501
    contact_id: StrictStr = Field(description="The unique ID of the contact for which the report is being generated.")
    included_activities_count: StrictInt = Field(description="The number of activities included in the calculation.")
    average_open_rate: Union[StrictFloat, StrictInt] = Field(description="The average rate the contact opened emails sent to them.")
    average_click_rate: Union[StrictFloat, StrictInt] = Field(description="The average rate the contact clicked on links in emails sent to them.")
    __properties: ClassVar[List[str]] = ["contact_id", "included_activities_count", "average_open_rate", "average_click_rate"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ContactOpenAndClickRates from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ContactOpenAndClickRates from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contact_id": obj.get("contact_id"),
            "included_activities_count": obj.get("included_activities_count"),
            "average_open_rate": obj.get("average_open_rate"),
            "average_click_rate": obj.get("average_click_rate")
        })
        return _obj


