# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from typing_extensions import Annotated
from constant_contact_api_client.models.create_contact_request_email_address import CreateContactRequestEmailAddress
from constant_contact_api_client.models.get_contact_by_id200_response_custom_fields_inner import GetContactById200ResponseCustomFieldsInner
from constant_contact_api_client.models.get_contact_by_id200_response_notes_inner import GetContactById200ResponseNotesInner
from constant_contact_api_client.models.update_contact_request_phone_numbers_inner import UpdateContactRequestPhoneNumbersInner
from constant_contact_api_client.models.update_contact_request_street_addresses_inner import UpdateContactRequestStreetAddressesInner
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ContactPostRequest(BaseModel):
    """
    ContactPostRequest
    """ # noqa: E501
    email_address: Optional[CreateContactRequestEmailAddress] = None
    first_name: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="The first name of the contact.")
    last_name: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="The last name of the contact.")
    job_title: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="The job title of the contact.")
    company_name: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="The name of the company where the contact works.")
    create_source: Optional[StrictStr] = Field(default=None, description="Describes who added the contact; valid values are <code>Contact</code> or <code>Account</code>. Your integration must accurately identify <code>create_source</code> for compliance reasons; value is set on POST, and is read-only going forward.")
    birthday_month: Optional[StrictInt] = Field(default=None, description="The month value for the contact's birthday. Valid values are from 1 through 12. The <code>birthday_month</code> property is required if you use <code>birthday_day</code>.")
    birthday_day: Optional[StrictInt] = Field(default=None, description="The day value for the contact's birthday. Valid values are from 1 through 31. The <code>birthday_day</code> property is required if you use <code>birthday_month</code>.")
    anniversary: Optional[Annotated[str, Field(strict=True, max_length=10)]] = Field(default=None, description="The anniversary date for the contact. For example, this value could be the date when the contact first became a customer of an organization in Constant Contact. Valid date formats are MM/DD/YYYY, M/D/YYYY, YYYY/MM/DD, YYYY/M/D, YYYY-MM-DD, YYYY-M-D,M-D-YYYY, or M-DD-YYYY.")
    custom_fields: Optional[Annotated[List[GetContactById200ResponseCustomFieldsInner], Field(max_length=25)]] = Field(default=None, description="Array of up to 25 <code>custom_field</code> key value pairs.")
    phone_numbers: Optional[Annotated[List[UpdateContactRequestPhoneNumbersInner], Field(max_length=3)]] = Field(default=None, description="Array of up to 3 phone numbers subresources.")
    street_addresses: Optional[Annotated[List[UpdateContactRequestStreetAddressesInner], Field(max_length=3)]] = Field(default=None, description="Array of up to 3 street address subresources.")
    list_memberships: Optional[Annotated[List[StrictStr], Field(max_length=50)]] = Field(default=None, description="Array of <code>list_id</code>s to which the contact is being subscribed, up to a maximum of 50.")
    taggings: Optional[Annotated[List[StrictStr], Field(max_length=50)]] = Field(default=None, description="Array of tags (<code>tag_id</code>) assigned to the contact, up to a maximum of 50.")
    notes: Optional[Annotated[List[GetContactById200ResponseNotesInner], Field(max_length=150)]] = Field(default=None, description="An array of notes about the contact.")
    __properties: ClassVar[List[str]] = ["email_address", "first_name", "last_name", "job_title", "company_name", "create_source", "birthday_month", "birthday_day", "anniversary", "custom_fields", "phone_numbers", "street_addresses", "list_memberships", "taggings", "notes"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ContactPostRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of email_address
        if self.email_address:
            _dict['email_address'] = self.email_address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in custom_fields (list)
        _items = []
        if self.custom_fields:
            for _item in self.custom_fields:
                if _item:
                    _items.append(_item.to_dict())
            _dict['custom_fields'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in phone_numbers (list)
        _items = []
        if self.phone_numbers:
            for _item in self.phone_numbers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['phone_numbers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in street_addresses (list)
        _items = []
        if self.street_addresses:
            for _item in self.street_addresses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['street_addresses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in notes (list)
        _items = []
        if self.notes:
            for _item in self.notes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['notes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ContactPostRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "email_address": CreateContactRequestEmailAddress.from_dict(obj.get("email_address")) if obj.get("email_address") is not None else None,
            "first_name": obj.get("first_name"),
            "last_name": obj.get("last_name"),
            "job_title": obj.get("job_title"),
            "company_name": obj.get("company_name"),
            "create_source": obj.get("create_source"),
            "birthday_month": obj.get("birthday_month"),
            "birthday_day": obj.get("birthday_day"),
            "anniversary": obj.get("anniversary"),
            "custom_fields": [GetContactById200ResponseCustomFieldsInner.from_dict(_item) for _item in obj.get("custom_fields")] if obj.get("custom_fields") is not None else None,
            "phone_numbers": [UpdateContactRequestPhoneNumbersInner.from_dict(_item) for _item in obj.get("phone_numbers")] if obj.get("phone_numbers") is not None else None,
            "street_addresses": [UpdateContactRequestStreetAddressesInner.from_dict(_item) for _item in obj.get("street_addresses")] if obj.get("street_addresses") is not None else None,
            "list_memberships": obj.get("list_memberships"),
            "taggings": obj.get("taggings"),
            "notes": [GetContactById200ResponseNotesInner.from_dict(_item) for _item in obj.get("notes")] if obj.get("notes") is not None else None
        })
        return _obj


