# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel
from pydantic import Field
from typing_extensions import Annotated
from constant_contact_api_client.models.create_email_campaign_request_email_campaign_activities_inner import CreateEmailCampaignRequestEmailCampaignActivitiesInner
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CreateEmailCampaignRequest(BaseModel):
    """
    CreateEmailCampaignRequest
    """ # noqa: E501
    name: Annotated[str, Field(strict=True, max_length=80)] = Field(description="The unique and descriptive name that you specify for the email campaign.")
    email_campaign_activities: List[CreateEmailCampaignRequestEmailCampaignActivitiesInner] = Field(description="The content of the email campaign as an array that contains a single email campaign activity object.")
    __properties: ClassVar[List[str]] = ["name", "email_campaign_activities"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CreateEmailCampaignRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in email_campaign_activities (list)
        _items = []
        if self.email_campaign_activities:
            for _item in self.email_campaign_activities:
                if _item:
                    _items.append(_item.to_dict())
            _dict['email_campaign_activities'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CreateEmailCampaignRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "email_campaign_activities": [CreateEmailCampaignRequestEmailCampaignActivitiesInner.from_dict(_item) for _item in obj.get("email_campaign_activities")] if obj.get("email_campaign_activities") is not None else None
        })
        return _obj


