# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictInt, StrictStr
from pydantic import Field
from typing_extensions import Annotated
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CreateListAddActivityRequestSource(BaseModel):
    """
    The <code>source</code> object specifies which contacts you are adding to your targeted lists using one of four mutually exclusive properties.
    """ # noqa: E501
    list_ids: Optional[Annotated[List[StrictStr], Field(max_length=50)]] = Field(default=None, description="Specifies which contacts you are adding to lists as an array of up to 50 contact <code>list_id</code> values. This property is mutually exclusive with <code>contact_ids</code>, <code>all_active_contacts</code> (billable), and <code>segment_id</code>.")
    all_active_contacts: Optional[StrictBool] = Field(default=False, description="Adds all active (billable) contacts to your targeted lists. This property is mutually exclusive with <code>contact_ids</code>, <code>list_ids</code>, and <code>segment_id</code>.")
    contact_ids: Optional[Annotated[List[StrictStr], Field(max_length=500)]] = Field(default=None, description="Specifies which contacts (up to 500) you are adding to lists as an array of <code>contact_id</code> values. This property is mutually exclusive with <code>list_ids</code>, <code>all_active_contacts</code> (billable), and <code>segment_id</code>.")
    tag_ids: Optional[Annotated[List[StrictStr], Field(max_length=0)]] = Field(default=None, description="Adds all contacts assigned with the specified <code>tag_id</code>s to your target lists. This property is mutually exclusive with all other <code>source</code> properties.")
    engagement_level: Optional[StrictStr] = Field(default=None, description="Adds all contacts that meet the selected  <code>engagement_level </code> to your target lists. This property is mutually exclusive with all other <code>source</code> properties.")
    segment_id: Optional[StrictInt] = Field(default=None, description="Specifies which contacts you are adding to lists as a single <code>segment_id</code> value. This property is mutually exclusive with <code>list_ids</code>, <code>all_active_contacts</code> (billable), and <code>contact_ids</code>.")
    __properties: ClassVar[List[str]] = ["list_ids", "all_active_contacts", "contact_ids", "tag_ids", "engagement_level", "segment_id"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CreateListAddActivityRequestSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CreateListAddActivityRequestSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "list_ids": obj.get("list_ids"),
            "all_active_contacts": obj.get("all_active_contacts") if obj.get("all_active_contacts") is not None else False,
            "contact_ids": obj.get("contact_ids"),
            "tag_ids": obj.get("tag_ids"),
            "engagement_level": obj.get("engagement_level"),
            "segment_id": obj.get("segment_id")
        })
        return _obj


