# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictStr
from pydantic import Field
from typing_extensions import Annotated
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CreateTagRemoveActivityRequestSource(BaseModel):
    """
    Select the source used to identify contacts to which a tag is added or removed. Source types are mutually exclusive.
    """ # noqa: E501
    contact_ids: Optional[Annotated[List[StrictStr], Field(max_length=500)]] = Field(default=None, description="An array of contacts IDs.")
    list_ids: Optional[Annotated[List[StrictStr], Field(max_length=50)]] = Field(default=None, description="An array of list IDs ( <code>list_id</code> ).")
    tag_ids: Optional[Annotated[List[StrictStr], Field(max_length=50)]] = Field(default=None, description="An array of tags ( <code>tag_id</code> ).")
    all_active_contacts: Optional[StrictBool] = Field(default=None, description="Use to identify contacts with an active (billable) status.")
    new_subscriber: Optional[StrictBool] = Field(default=None, description="Use to identify newly subscribed contacts.")
    __properties: ClassVar[List[str]] = ["contact_ids", "list_ids", "tag_ids", "all_active_contacts", "new_subscriber"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CreateTagRemoveActivityRequestSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CreateTagRemoveActivityRequestSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contact_ids": obj.get("contact_ids"),
            "list_ids": obj.get("list_ids"),
            "tag_ids": obj.get("tag_ids"),
            "all_active_contacts": obj.get("all_active_contacts"),
            "new_subscriber": obj.get("new_subscriber")
        })
        return _obj


