# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GetAccountDetails200ResponseCompanyLogo(BaseModel):
    """
    Used to include an existing company logo in the response body. If a company logo does not exist, nothing is returned in the response body. This property is optional.
    """ # noqa: E501
    url: Optional[StrictStr] = Field(default=None, description="The internal URL used to get the company logo image file hosted locally in your account's MyLibrary.")
    external_url: Optional[StrictStr] = Field(default=None, description="The external URL used to get the company logo image file that is hosted on an external website.")
    internal_id: Optional[StrictStr] = Field(default=None, description="The internal ID used to identify the image hosted in your account's MyLibrary.")
    __properties: ClassVar[List[str]] = ["url", "external_url", "internal_id"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GetAccountDetails200ResponseCompanyLogo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GetAccountDetails200ResponseCompanyLogo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "url": obj.get("url"),
            "external_url": obj.get("external_url"),
            "internal_id": obj.get("internal_id")
        })
        return _obj


