# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GetEmailCampaignReport200ResponseAggregatePercents(BaseModel):
    """
    Lists aggregate percents for  `click`, `open`, `did_not_open`, `bounce`, and  `unsubscribe` activities for all campaigns included on a page of results.
    """ # noqa: E501
    click: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Aggregated click rate for campaigns on the current page.")
    open: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Aggregated open rate for campaigns on the current page.")
    did_not_open: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Aggregated did-not-open rate for campaigns on the current page.")
    bounce: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Aggregated bounce rate for campaigns on the current page.")
    unsubscribe: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Aggregated unsubscribe (optout) rate for campaigns on the current page.")
    __properties: ClassVar[List[str]] = ["click", "open", "did_not_open", "bounce", "unsubscribe"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GetEmailCampaignReport200ResponseAggregatePercents from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GetEmailCampaignReport200ResponseAggregatePercents from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "click": obj.get("click"),
            "open": obj.get("open"),
            "did_not_open": obj.get("did_not_open"),
            "bounce": obj.get("bounce"),
            "unsubscribe": obj.get("unsubscribe")
        })
        return _obj


