# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
from constant_contact_api_client.models.get_sms_engagement_history200_response_inner_history_details import GetSmsEngagementHistory200ResponseInnerHistoryDetails
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GetSmsEngagementHistory200ResponseInner(BaseModel):
    """
    Provides a contact's SMS engagement history details. The properties returned depend on the type of SMS consent granted by the contact.
    """ # noqa: E501
    contact_id: Optional[StrictStr] = Field(default=None, description="The unique contact UUID.")
    sms_channel_id: Optional[StrictStr] = Field(default=None, description="The unique SMS channel UUID.")
    sms_channel_history_id: Optional[StrictStr] = Field(default=None, description="The unique SMS channel history UUID.")
    insert_time: Optional[datetime] = Field(default=None, description="The date and time that the history record was created, in ISO-8601 format. System generated.")
    history_details: Optional[GetSmsEngagementHistory200ResponseInnerHistoryDetails] = None
    __properties: ClassVar[List[str]] = ["contact_id", "sms_channel_id", "sms_channel_history_id", "insert_time", "history_details"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GetSmsEngagementHistory200ResponseInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of history_details
        if self.history_details:
            _dict['history_details'] = self.history_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GetSmsEngagementHistory200ResponseInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contact_id": obj.get("contact_id"),
            "sms_channel_id": obj.get("sms_channel_id"),
            "sms_channel_history_id": obj.get("sms_channel_history_id"),
            "insert_time": obj.get("insert_time"),
            "history_details": GetSmsEngagementHistory200ResponseInnerHistoryDetails.from_dict(obj.get("history_details")) if obj.get("history_details") is not None else None
        })
        return _obj


