# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from pydantic import Field
from constant_contact_api_client.models.partner_account_links import PartnerAccountLinks
from constant_contact_api_client.models.partner_account_site_owner_list_inner import PartnerAccountSiteOwnerListInner
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class PartnerAccount(BaseModel):
    """
    PartnerAccount
    """ # noqa: E501
    site_owner_list: List[PartnerAccountSiteOwnerListInner] = Field(description="Lists all Constant Contact client accounts that are managed under a partner account.")
    links: Optional[PartnerAccountLinks] = Field(default=None, alias="_links")
    __properties: ClassVar[List[str]] = ["site_owner_list", "_links"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PartnerAccount from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in site_owner_list (list)
        _items = []
        if self.site_owner_list:
            for _item in self.site_owner_list:
                if _item:
                    _items.append(_item.to_dict())
            _dict['site_owner_list'] = _items
        # override the default output from pydantic by calling `to_dict()` of links
        if self.links:
            _dict['_links'] = self.links.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PartnerAccount from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "site_owner_list": [PartnerAccountSiteOwnerListInner.from_dict(_item) for _item in obj.get("site_owner_list")] if obj.get("site_owner_list") is not None else None,
            "_links": PartnerAccountLinks.from_dict(obj.get("_links")) if obj.get("_links") is not None else None
        })
        return _obj


