# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class Tag(BaseModel):
    """
    Tag
    """ # noqa: E501
    tag_id: Optional[StrictStr] = Field(default=None, description="The ID that uniquely identifies a tag (UUID format)")
    name: Optional[StrictStr] = Field(default=None, description="The unique tag name.")
    contacts_count: Optional[StrictInt] = Field(default=None, description="The total number of contacts who are assigned this tag.")
    created_at: Optional[datetime] = Field(default=None, description="The system generated date and time when the tag was created (ISO-8601 format).")
    updated_at: Optional[datetime] = Field(default=None, description="The system generated date and time when the tag was last updated (ISO-8601 format).")
    tag_source: Optional[StrictStr] = Field(default=None, description="The source used to tag contacts.")
    __properties: ClassVar[List[str]] = ["tag_id", "name", "contacts_count", "created_at", "updated_at", "tag_source"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of Tag from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
                "contacts_count",
                "created_at",
                "updated_at",
                "tag_source",
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of Tag from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tag_id": obj.get("tag_id"),
            "name": obj.get("name"),
            "contacts_count": obj.get("contacts_count"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "tag_source": obj.get("tag_source")
        })
        return _obj


