# coding: utf-8

"""
    Constant Contact API v3

    Swagger build version 3.0.2475

    The version of the OpenAPI document: 1.0.97
    Contact: webservices@constantcontact.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
from typing_extensions import Annotated
from constant_contact_api_client.models.create_tag_remove_activity_request_exclude import CreateTagRemoveActivityRequestExclude
from constant_contact_api_client.models.create_tag_remove_activity_request_source import CreateTagRemoveActivityRequestSource
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class TagAddRemoveContacts(BaseModel):
    """
    TagAddRemoveContacts
    """ # noqa: E501
    source: CreateTagRemoveActivityRequestSource
    exclude: Optional[CreateTagRemoveActivityRequestExclude] = None
    tag_ids: Annotated[List[StrictStr], Field(max_length=50)] = Field(description="An array of tags (<code>tag_id</code>) to add to all contacts meeting the specified source criteria.")
    __properties: ClassVar[List[str]] = ["source", "exclude", "tag_ids"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of TagAddRemoveContacts from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        # override the default output from pydantic by calling `to_dict()` of exclude
        if self.exclude:
            _dict['exclude'] = self.exclude.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of TagAddRemoveContacts from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "source": CreateTagRemoveActivityRequestSource.from_dict(obj.get("source")) if obj.get("source") is not None else None,
            "exclude": CreateTagRemoveActivityRequestExclude.from_dict(obj.get("exclude")) if obj.get("exclude") is not None else None,
            "tag_ids": obj.get("tag_ids")
        })
        return _obj


